SystemOrganization addCategory: #Mass!

Object subclass: #MassBackEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

!MassBackEnd methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 3/21/2016 15:28'!
open: request

	Transcript show: (request at: #user).
	
	^ { #availablePlans -> { 'filename1', 'filename2' } asArray } asDictionary! !

!MassBackEnd methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 3/21/2016 11:49'!
viewEdit: request

	Transcript show: (request at: #user).
	
	^ { #seems -> 'to work' } asDictionary! !

Object subclass: #MassLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassPlan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassServer
	instanceVariableNames: 'mBackEnd teapotInstance mode allowedRequests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:33'!
allowedRequests

	^ allowedRequests ifNil:[ allowedRequests := MassBackEnd selectors ].! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:50'!
deployment

	teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080. 
			#debugMode -> false }.

	self serveStatic.
	
	teapotInstance "this is for development ONLY for obvious reasons"
		POST: '/api/<expression>' -> [ :req | self deploymentResponse: req ].! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:38'!
deploymentResponse: req

	^ [self sanitize: req. mBackEnd perform: (req at: #expression) asSymbol with: req] 
				on: Error 
				do: [ :ex | ex description ].
		"it expects expressions that return compatible values for JSON encoding"
			! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:18'!
development

	teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080. 
			#debugMode -> true }.
			
	self serveStatic.
	
	teapotInstance "this is for development ONLY for obvious reasons"
		POST: '/api/<expression>' -> [ :req | self developmentResponse: req ].
			! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 16:37'!
developmentResponse: req

	^ [self sanitize: req. mBackEnd perform: (req at: #expression) asSymbol with: req] 
				on: Error 
				do: [ :ex | ex description ].
		"it expects expressions that return compatible values for JSON encoding"
			! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
forDeployment

	mode := #deployment.

	"teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080 }.	"! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
forDevelopment

	mode := #development! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 17:12'!
initialize

	mBackEnd := MassBackEnd new.
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 3/21/2016 15:42'!
sanitize: req

	(self allowedRequests includes: (req at: #expression))
		ifFalse: [ Error signal: 'Not a valid Request: ' , (req at: #expression) ]
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/3/2016 14:06'!
serveStatic

	teapotInstance 
		serveStatic: '/' 
		from: (SmalltalkImage current 
					imageDirectory parent parent 
					parent asFileReference pathString , '/static').
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
start

	self perform: mode.
	teapotInstance start.
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 17:38'!
stop

	teapotInstance start
	! !

Object subclass: #MassSimulation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #SanityExample
	instanceVariableNames: 'parser processModel definition bpSimExecution bpSimEngine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/15/2016 14:24'!
allMetrics 
	
	^ { #CFCRel -> processModel metricCFCRel.
	#NOA -> processModel metricNOA .
	#NOAC -> processModel metricNOAC .
	#PDiffic -> processModel metricProcessDifficulty .
	#PLength -> processModel metricProcessLength .
	#PVolume -> processModel metricProcessVolume. }! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/16/2016 12:37'!
axisAdaptedExample

	"see in examples browser and replicate from there"! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/15/2016 14:26'!
display
	
	self allMetrics inspect.
	self staticAnalysis inspect.
	self dynamicAnalysis inspect.
	! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/15/2016 14:25'!
dynamicAnalysis 
	
	| view composer|
	view := RTView new.
	composer := RTComposer new.
	composer view:view.
	composer gap: 50.

	self plot01Basic: composer group:#BPMN.
	self plot01Historical: composer group: #Time.	


	"self plot01Mondrian: composer  group: #Mondrian01."
	
	composer move: #Time onTheRightOf: #BPMN.
	"composer move: #BPMN below: #Mondrian01."
	composer nameGroup: #BPMN as: 'Bussines Process Notation'.
	composer nameGroup: #Time as: 'Time information'.
	"composer nameGroup: #Mondrian01 as: 'Mondrian01'."
	composer view canvas camera focusOnCenterScaled.

	^ composer view! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/15/2016 17:57'!
initialize 
	|stream xmlContents|
	stream := FileStream readOnlyFileNamed: 'ResponseTsunamiHM.bpmn'.
	xmlContents := stream contents.
	stream close.
	parser := BPMN20Parser parseString: xmlContents.
	processModel := parser definitions first.
	self simulate.
	! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/16/2016 12:31'!
plot01Basic: composer group: group
	|view out model cv values eb|

	out :=  bpSimExecution out.
	view := RTMondrian new.
	view view: composer view.
	model := bpSimExecution processModel.
	out := bpSimExecution out.	
	"Execute the visulization"
	
	cv := A4BPUIBVFactory color.
	view interaction action:[ :n | n inspect].
	values := model flowElements.
	view shape rectangle color:[: n | (n accept: cv)].
	view shape rectangle 
		width:[: n | (out getParameterAt: n) processing vv ];
		height:[: n | ( n metricCFC  + 1 ) ];
		color:[: n | (n accept: cv) alpha: 0.9 "1 - (1 / (n numberOfRelations + 1) )"].
	view nodes: values.
	view normalizer
	normalizeColor: #numberOfRelations "[:n | (out getParameterAt: n ) quantity vv] "using: (ColorPalette sequential colors: 9 scheme: 'YlOrRd') using: #value.
	eb := view edges.
	eb shape line color:(Color lightGray "alpha:0.2").
	eb connectFrom:#yourself toAll:[ :n | n outFlows].
	view layout tree.
	view build.
	
	
	
	
	composer layout: RTVerticalLineLayout new.
	composer propagateHighlight.
	composer group: group.
	composer propagateHighlightToAll.	! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/15/2016 12:00'!
plot01Historical: composer group: group
	| ds cv i b scenario cvv|
	" each simulation is a scenario to display"
	b := RTGrapher new.
	"b extent: 600 @ 300."
	b view: composer view.
	b interaction popup.
	b view @ RTDraggableView.
	cv := Dictionary new.
	cvv := A4BPUIBVFactory color.
	i := 0.
	scenario :=  bpSimExecution fullOutputScenario.
	scenario elementParameters do: [ :p | 
		cv at: p elementRef id put: ( p  elementRef accept: cvv ) ].
	i := i + 1.
	ds := RTStackedDataSet new.
	ds interaction popup text: [ :el | el aName ].
	ds dotShape rectangle
		width:[ :el |  | p v |
			p := scenario getParameterAt: el.
			v := ( p quantity vv ) + 1. 
			v * 2];
		height: 5;
		color: [ :el | cv at: el id ].
	ds points: bpSimExecution processModel allActivities.
	ds y: [ :el |  | p v |
			p := scenario getParameterAt: el.
			v := ( p processing vv ) + 1. 
			v ].
	ds x: [ :el | i := i + 1 ].
	b add: ds.
	b axisX title: 'Activities'.
	b axisY title: 'Processing time'.
	b build.
	composer propagateHighlight.
	composer group: group! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/15/2016 15:09'!
scenario01
|simb task gateways ts|
simb := BPSimBuilder buildScenarioId: 'TsunamiScenario01'.
task := (processModel activities select: [ :a | a class = BPMN20TaskImpl  ]).
simb processModel: processModel.
ts := 5.

simb timer processingTime: ( simb duration value: 10 ) inElementName: 'T1 : Detect tsunami risk'.
simb timer processingTime: ( simb duration value: 15 ) inElementName: 'T2 : Inform tsunami start'.
simb timer processingTime: ( simb duration value: 10 ) inElementName:'T3 : Receive tsunami start '.
simb timer processingTime: ( simb duration value: 30 ) inElementName:'T4 : Fire the flares'.
simb timer processingTime: ( simb duration value: 30 ) inElementName: 'T5 : Notify functional units to start'.
simb timer processingTime: ( simb duration value: 60 ) inElementName: 'T6 : Inform by portable speakers'.
simb timer processingTime: ( simb duration value: 30 ) inElementName:'T7 : Broadcast over the media'.
simb timer processingTime: ( simb duration value: 180 ) inElementName:'T8 : Evacuate people'.
simb timer processingTime: ( simb duration value: 180 ) inElementName: 'T8'' : Evacuate people'.
simb timer processingTime: ( simb duration value: 180 ) inElementName:'T9 : Transfer injuries to safe places'.
simb timer processingTime: ( simb duration value: 180 ) inElementName:'T9'' : Transfer injuries to safe places'.
simb timer processingTime: ( simb duration value: 180 ) inElementName:'T10 : Inform, guide the fisherman'.
simb timer processingTime: ( simb duration value: 180 ) inElementName:'T11 : Protect the property'.
simb timer processingTime: ( simb duration value: 180 ) inElementName:'T12 : Perform the first aid'.
simb timer processingTime: ( simb duration value: 30 ) inElementName:'T13 : Call ambulance '.
simb timer processingTime: ( simb duration value: 10 ) inElementName:'T14 : Detect tsunami end'.
simb timer processingTime: ( simb duration value: 15 ) inElementName:'T15 : Inform tsunami end'.
simb timer processingTime: ( simb duration value: 10 ) inElementName:'T16 : Receive tsunami end'.
simb timer processingTime: ( simb duration value: 30 ) inElementName:'T17 : Notify functional units to end'.
simb timer processingTime: ( simb duration value: 60 ) inElementName:'T18 : Identify damages'.
simb timer processingTime: ( simb duration value: 60 ) inElementName:'T18'' : Identify damages'.
simb timer processingTime: ( simb duration value: 60 ) inElementName:'T19 : Search distress fishermen'.
simb timer processingTime: ( simb duration value: 60 ) inElementName:'T19'' : Search distress fishermen'.
simb timer processingTime: ( simb duration value: 30 ) inElementName:'T20 : Close tsunami reponse'.



gateways := (processModel activities select: [ :a | a class superclass = BPMN20GatewayImpl ]).

gateways do:[ :g | simb control probabilityParameterOnGateway: g ].

^ simb currentScenario.! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/23/2016 12:46'!
simulate 
	|simProcesses seconds|
	seconds := 0.
	bpSimEngine := BPSimBPMN20EngineProcess new.
	bpSimEngine addProcessModel: processModel.
	simProcesses := bpSimEngine runSimulationUsing: self scenario01 for: 1.
	[ (simProcesses select: [ :sp | sp isTerminated not ]) isEmpty ]
		whileFalse: [ (Delay forSeconds: 1) wait. seconds := seconds + 1. 
			Transcript 
				show: '===========';cr;
				show: seconds; show: ' sec'; cr;
				show: '===========';cr].
	bpSimExecution := bpSimEngine simulations first.! !

!SanityExample methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/15/2016 18:06'!
staticAnalysis 
	
	|rtView view model cv eb lb values entities |
	rtView := RTView new.
	view := RTMondrian new.
	view view: rtView.
	rtView @ RTDraggableView .
	model := processModel.

	"Execute the visulization"
	
	cv := A4BPUIBVFactory color.
	view interaction action:[ :n | n inspect].
	values := model flowElements.
	view shape rectangle 
		width:[: nn | (nn metricCFC + 1) * 10 ];
		height:[: nn | ( nn metricCFCAbs  + 1 ) * 10 ];
		color:[: nn | (nn accept: cv) alpha:  0.9].
	view nodes: values.
	"Blues, PuBuGn, BuPu, GnBu, YlGn, Greens, YlOrBr, YlOrRd, Greys, Reds, YlGnBu, PuRd, RdPu, PuBu, BuGn, Oranges, Purples, OrRd"
	view normalizer
	normalizeColor: #numberOfRelations using: (ColorPalette sequential colors: 9 scheme: 'YlOrRd') using: #value.
	eb := view edges.
	eb shape line color:(Color lightGray).
	eb connectFrom:#yourself toAll:[ :n | n outFlows].
	view layout tree.
	view build.
	
	
	lb := RTLegendBuilder new view: view view.
	lb addText:'width:[: n | n metricCFCAbs]'.
	lb addText:'height:[: n | n metricCFC]'.
	lb addText:'color alpha:[: n | n numberOfRelations]'.
	entities := Dictionary new.
	values do:[ :p | entities at: p class put: p class].
	entities do:[ :p |  lb addColor:(p new accept: cv) text: p bpmn20Name ].
	lb right.
	lb build.
	
	^ view ! !
